diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/antenna/model/circular-aperture-antenna-model.cc ns-3.42/src/antenna/model/circular-aperture-antenna-model.cc
--- ns-3.41/src/antenna/model/circular-aperture-antenna-model.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.42/src/antenna/model/circular-aperture-antenna-model.cc	2024-05-29 15:29:46.916073000 -0700
@@ -0,0 +1,193 @@
+/*
+ * Copyright (c) 2022 University of Padova, Dep. of Information Engineering, SIGNET lab.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Mattia Sandri <mattia.sandri@unipd.it>
+ */
+
+#include "circular-aperture-antenna-model.h"
+
+// The host system uses Clang libc++, which does not support the Mathematical special functions
+// (P0226R1) and Boost's implementation of cyl_bessel_j has been found.
+#ifdef NEED_AND_HAVE_BOOST_BESSEL_FUNC
+#include <boost/math/special_functions/bessel.hpp>
+#endif
+
+#include "antenna-model.h"
+
+#include <ns3/double.h>
+#include <ns3/log.h>
+
+#include <math.h>
+
+/**
+ *  \file
+ *  \ingroup antenna
+ *  Class CircularApertureAntennaModel implementation.
+ */
+
+namespace
+{
+constexpr double C = 299792458.0; ///< speed of light in vacuum, in m/s
+} // namespace
+
+namespace ns3
+{
+NS_LOG_COMPONENT_DEFINE("CircularApertureAntennaModel");
+
+NS_OBJECT_ENSURE_REGISTERED(CircularApertureAntennaModel);
+
+TypeId
+CircularApertureAntennaModel::GetTypeId()
+{
+    static TypeId tid =
+        TypeId("ns3::CircularApertureAntennaModel")
+            .SetParent<AntennaModel>()
+            .SetGroupName("Antenna")
+            .AddConstructor<CircularApertureAntennaModel>()
+            .AddAttribute("AntennaCircularApertureRadius",
+                          "The radius of the aperture of the antenna, in meters",
+                          DoubleValue(0.5),
+                          MakeDoubleAccessor(&CircularApertureAntennaModel::SetApertureRadius),
+                          MakeDoubleChecker<double>(0.0))
+            .AddAttribute("OperatingFrequency",
+                          "The operating frequency in Hz of the antenna",
+                          DoubleValue(2e9),
+                          MakeDoubleAccessor(&CircularApertureAntennaModel::SetOperatingFrequency),
+                          MakeDoubleChecker<double>(0.0))
+            .AddAttribute("AntennaMinGainDb",
+                          "The minimum gain value in dB of the antenna",
+                          DoubleValue(-100.0),
+                          MakeDoubleAccessor(&CircularApertureAntennaModel::SetMinGain),
+                          MakeDoubleChecker<double>())
+            .AddAttribute("AntennaMaxGainDb",
+                          "The maximum gain value in dB of the antenna",
+                          DoubleValue(1),
+                          MakeDoubleAccessor(&CircularApertureAntennaModel::SetMaxGain),
+                          MakeDoubleChecker<double>(0.0));
+    return tid;
+}
+
+void
+CircularApertureAntennaModel::SetApertureRadius(double aMeter)
+{
+    NS_LOG_FUNCTION(this << aMeter);
+    NS_ASSERT_MSG(aMeter > 0, "Setting invalid aperture radius: " << aMeter);
+    m_apertureRadiusMeter = aMeter;
+}
+
+double
+CircularApertureAntennaModel::GetApertureRadius() const
+{
+    return m_apertureRadiusMeter;
+}
+
+void
+CircularApertureAntennaModel::SetOperatingFrequency(double freqHz)
+{
+    NS_LOG_FUNCTION(this << freqHz);
+    NS_ASSERT_MSG(freqHz > 0, "Setting invalid operating frequency: " << freqHz);
+    m_operatingFrequencyHz = freqHz;
+}
+
+double
+CircularApertureAntennaModel::GetOperatingFrequency() const
+{
+    return m_operatingFrequencyHz;
+}
+
+void
+CircularApertureAntennaModel::SetMaxGain(double gainDb)
+{
+    NS_LOG_FUNCTION(this << gainDb);
+    m_maxGain = gainDb;
+}
+
+double
+CircularApertureAntennaModel::GetMaxGain() const
+{
+    return m_maxGain;
+}
+
+void
+CircularApertureAntennaModel::SetMinGain(double gainDb)
+{
+    NS_LOG_FUNCTION(this << gainDb);
+    m_minGain = gainDb;
+}
+
+double
+CircularApertureAntennaModel::GetMinGain() const
+{
+    return m_minGain;
+}
+
+double
+CircularApertureAntennaModel::GetGainDb(Angles a)
+{
+    NS_LOG_FUNCTION(this << a);
+
+    // In 3GPP TR 38.811 v15.4.0, Section 6.4.1, the gain depends on a single angle only.
+    // We assume that this angle represents the angle between the vectors corresponding
+    // to the cartesian coordinates of the provided spherical coordinates, and the spherical
+    // coordinates (r = 1, azimuth = 0, elevation = PI/2)
+    double theta1 = a.GetInclination();
+    double theta2 = M_PI_2; // reference direction
+
+    // Convert to ISO range: the input azimuth angle phi is in [-pi,pi],
+    // while the ISO convention for spherical to cartesian coordinates
+    // assumes phi in [0,2*pi].
+    double phi1 = M_PI + a.GetAzimuth();
+    double phi2 = M_PI; // reference direction
+
+    // Convert the spherical coordinates of the boresight and the incoming ray
+    // to Cartesian coordinates
+    Vector p1(sin(theta1) * cos(phi1), sin(theta1) * sin(phi1), cos(theta1));
+    Vector p2(sin(theta2) * cos(phi2), sin(theta2) * sin(phi2), cos(theta2));
+
+    // Calculate the angle between the antenna boresight and the incoming ray
+    double theta = acos(p1 * p2);
+
+    double gain = 0;
+    if (theta == 0)
+    {
+        gain = m_maxGain;
+    }
+    // return value of std::arccos is in [0, PI] deg
+    else if (theta >= M_PI_2)
+    {
+        // This is an approximation. 3GPP TR 38.811 does not provide indications
+        // on the antenna field pattern outside its PI degrees FOV.
+        gain = m_minGain;
+    }
+    else // 0 < theta < |PI/2|
+    {
+        // 3GPP TR 38.811 v15.4.0, Section 6.4.1
+        double k = (2 * M_PI * m_operatingFrequencyHz) / C;
+        double kasintheta = k * m_apertureRadiusMeter * sin(theta);
+// If needed, fall back to Boost cyl_bessel_j
+#ifdef NEED_AND_HAVE_BOOST_BESSEL_FUNC
+        gain = boost::math::cyl_bessel_j(1, kasintheta) / kasintheta;
+// Otherwise, use the std implementation
+#else
+        gain = std::cyl_bessel_j(1, kasintheta) / kasintheta;
+#endif
+        gain = 10 * log10(4 * gain * gain) + m_maxGain;
+    }
+
+    return gain;
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/antenna/model/circular-aperture-antenna-model.h ns-3.42/src/antenna/model/circular-aperture-antenna-model.h
--- ns-3.41/src/antenna/model/circular-aperture-antenna-model.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.42/src/antenna/model/circular-aperture-antenna-model.h	2024-05-29 15:29:46.916073000 -0700
@@ -0,0 +1,140 @@
+/*
+ * Copyright (c) 2022 University of Padova, Dep. of Information Engineering, SIGNET lab.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Mattia Sandri <mattia.sandri@unipd.it>
+ */
+
+#ifndef CIRCULAR_APERTURE_ANTENNA_MODEL_H
+#define CIRCULAR_APERTURE_ANTENNA_MODEL_H
+
+#include "antenna-model.h"
+
+#include <ns3/object.h>
+
+/**
+ * \file
+ * \ingroup antenna
+ * Class CircularApertureAntennaModel declaration
+ */
+
+namespace ns3
+{
+/**
+ * \brief Circular Aperture Antenna Model
+ *
+ * This class implements the circular aperture antenna as described in 3GPP 38.811 6.4.1
+ * https://www.3gpp.org/ftp/Specs/archive/38_series/38.811 without the cosine approximation, thanks
+ * to the Bessel functions introduced in C++17. Spherical coordinates are used, in particular of the
+ * azimuth and inclination angles. All working parameters can be set, namely: operating frequency,
+ * aperture radius, maximum and minimum gain.
+ * Since Clang libc++ does not support the Mathematical special functions (P0226R1) yet, this class
+ * falls back to Boost's implementation of cyl_bessel_j whenever the above standard library is in
+ * use. If neither is available in the host system, this class is not compiled.
+ */
+class CircularApertureAntennaModel : public AntennaModel
+{
+  public:
+    CircularApertureAntennaModel() = default;
+    ~CircularApertureAntennaModel() override = default;
+
+    /**
+     * Register this type.
+     * \return The object TypeId.
+     */
+    static TypeId GetTypeId();
+
+    /**
+     * \brief Set the antenna aperture radius
+     *
+     * Sets the antenna operating frequency, asserting that
+     * the provided value is within the acceptable range [0, +inf[.
+     *
+     * \param aMeter the strictly positive antenna radius in meters
+     */
+    void SetApertureRadius(double aMeter);
+
+    /**
+     * \brief Return the antenna aperture radius
+     *
+     * \return the antenna radius in meters
+     */
+    double GetApertureRadius() const;
+
+    /**
+     * \brief Set the antenna operating frequency.
+     *
+     * Sets the antenna operating frequency, asserting that
+     * the provided value is within the acceptable range [0, +inf[.
+     *
+     * \param freqHz the strictly positive antenna operating frequency, in Hz
+     */
+    void SetOperatingFrequency(double freqHz);
+
+    /**
+     * \brief Return the antenna operating frequency
+     *
+     * \return the antenna operating frequency, in Hz
+     */
+    double GetOperatingFrequency() const;
+
+    /**
+     * \brief Set the antenna max gain
+     *
+     * \param gainDb the antenna max gain in dB
+     */
+    void SetMaxGain(double gainDb);
+
+    /**
+     * \brief Return the antenna max gain
+     *
+     * \return the antenna max gain in dB
+     */
+    double GetMaxGain() const;
+
+    /**
+     * \brief Set the antenna min gain
+     *
+     * \param gainDb the antenna min gain in dB
+     */
+    void SetMinGain(double gainDb);
+
+    /**
+     * \brief Return the antenna min gain
+     *
+     * \return the antenna min gain in dB
+     */
+    double GetMinGain() const;
+
+    /**
+     * \brief Get the gain in dB, using Bessel equation of first kind and first order.
+     *
+     * \param a the angle at which the gain need to be calculated with respect to the antenna
+     * bore sight
+     *
+     * \return the antenna gain at the specified Angles a
+     */
+    double GetGainDb(Angles a) override;
+
+  private:
+    double m_apertureRadiusMeter;  //!< antenna aperture radius in meters
+    double m_operatingFrequencyHz; //!< antenna operating frequency in Hz
+    double m_maxGain;              //!< antenna gain in dB towards the main orientation
+    double m_minGain;              //!< antenna min gain in dB
+};
+
+} // namespace ns3
+
+#endif // CIRCULAR_APERTURE_ANTENNA_MODEL_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/antenna/model/uniform-planar-array.cc ns-3.42/src/antenna/model/uniform-planar-array.cc
--- ns-3.41/src/antenna/model/uniform-planar-array.cc	2024-02-09 14:44:07.849789600 -0800
+++ ns-3.42/src/antenna/model/uniform-planar-array.cc	2024-05-29 15:29:46.916073000 -0700
@@ -212,10 +212,12 @@
 
     // convert the theta and phi angles from GCS to LCS using eq. 7.1-7 and 7.1-8 in 3GPP TR 38.901
     // NOTE we assume a fixed slant angle of 0 degrees
-    double cosIncl = cos(a.GetInclination());
-    double sinIncl = sin(a.GetInclination());
-    double cosAzim = cos(a.GetAzimuth() - m_alpha);
-    double sinAzim = sin(a.GetAzimuth() - m_alpha);
+    double inclination = a.GetInclination();
+    double azimuth = a.GetAzimuth();
+    double cosIncl = cos(inclination);
+    double sinIncl = sin(inclination);
+    double cosAzim = cos(azimuth - m_alpha);
+    double sinAzim = sin(azimuth - m_alpha);
     double thetaPrime = std::acos(m_cosBeta * cosIncl + m_sinBeta * cosAzim * sinIncl);
     double phiPrime =
         std::arg(std::complex<double>(m_cosBeta * sinIncl * cosAzim - m_sinBeta * cosIncl,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/antenna/test/gen-test-circular-aperture-antenna-reference-points.m ns-3.42/src/antenna/test/gen-test-circular-aperture-antenna-reference-points.m
--- ns-3.41/src/antenna/test/gen-test-circular-aperture-antenna-reference-points.m	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.42/src/antenna/test/gen-test-circular-aperture-antenna-reference-points.m	2024-05-29 15:29:46.916073000 -0700
@@ -0,0 +1,105 @@
+%{
+    Compute the antenna gain pattern of the reflector antenna with circular aperture
+    specified in the Sec. 6.4.1, 3GPP 38.811 v.15.4.0 and generate reference gain values
+    for the CircularApertureAntennaModelTest.
+%}
+clc; clearvars;
+
+%{
+    Consider two testing vectors, one with elevation fixed to 90 degrees and
+    varying azimuth, the other with azimuth fixed to 180 degrees and varying elevation.
+    The boresight direction, is (az, el) = (180 degrees, 90 degrees)
+%}
+az_test_fixed_el = 90:10:180;
+eL_test_fixed_az = 0:9:90;
+%  Uncomment line below and comment line below for the fixed elevation test
+[theta_vec, az_vec, el_vec] = theta_vec_from_sph_coord_vecs(az_test_fixed_el, 90);
+%  Uncomment line above and comment line below for the fixed azimuth test
+%[theta_vec, az_vec, el_vec] = theta_vec_from_sph_coord_vecs(180, eL_test_fixed_az);
+
+%{
+ The theta angle which represents the input of the pattern formula is
+ computed as theta = arccos(<p1, p2>), where p_i = sin(theta_i) *
+ cos(phi_i), sin(theta_i) * sin(phi_i), cos(theta_i). The default
+ boresight is (phi1 (az), theta1(el)) = (180deg, 90deg)
+%}
+
+%{
+    3GPP specifies the antenna gain only for |theta| < 90 degrees.
+    The gain outside of this region is approximated as min_gain_dB
+%}
+min_gain_dB = -50;
+
+max_gain_dB = 0;
+c=physconst('LightSpeed');
+f=28e9; % operating frequency
+k=2*pi*f/c; % wave number
+a=10*c/f; % radius antenna aperture
+arg_vec=k*a*sind(theta_vec);
+pattern=besselj(1, arg_vec)./arg_vec;
+pattern= 4*(abs(pattern).^2);
+
+% Manually set gain for theta = 0
+where_arg_zero=find(~theta_vec);
+pattern(where_arg_zero)=1;
+gain_dB=10*log10(pattern) + max_gain_dB;
+
+% Manually set gain to minimum gain for |theta| >= 90 degrees
+where_arg_outside_pattern_domain = find(abs(theta_vec) >= 90);
+gain_dB(where_arg_outside_pattern_domain)=min_gain_dB;
+
+%{
+    Plot and output the C++ code which defines the reference vector of data points.
+    Test points are assumed to be encoded as C++ structs
+%}
+scatter(theta_vec, gain_dB);
+out_str = ns3_output_from_vecs(az_vec, el_vec, gain_dB, max_gain_dB, min_gain_dB, a, f);
+
+
+function theta = theta_from_sph_coord(phi1, theta1)
+%    theta_from_sph_coord Computes theta (the input of the radiation pattern formula)
+%    from the azimuth and elevation angles with resepct to boresight.
+%    phi1 the azimuth with respect to boresight
+%    theta1 the elevation angle with respect to boresight
+
+    p1 = [sind(theta1)*cosd(phi1), sind(theta1)*sind(phi1), cosd(theta1)];
+    % p2, i.e., the boresight direction, is phi1 (az), theta1(el)) =
+    % (180deg, 90deg)
+    theta2 = 90; phi2 = 180;
+    p2 = [sind(theta2)*cosd(phi2), sind(theta2)*sind(phi2), cosd(theta2)];
+    theta = acosd(dot(p1,p2));
+end
+
+function [theta_vec, az_vec, el_vec] = theta_vec_from_sph_coord_vecs(az_vec, el_vec)
+%    theta_vec_from_sph_coord_vecs Computes the vectors of thetas
+%    (the inputs of the radiation pattern formula)
+%    from vectors of azimuth and elevation angles with resepct to boresight.
+%    phi1 the vector of azimuths with respect to boresight
+%    theta1 the vector of elevation angles with respect to boresight
+    if size(az_vec, 2) > 1
+        el_vec = repelem(el_vec, size(az_vec, 2));
+    elseif size(el_vec, 2) > 1
+        az_vec = repelem(az_vec, size(el_vec, 2));
+    end
+    theta_vec = arrayfun(@theta_from_sph_coord, az_vec, el_vec);
+end
+
+function out_str = ns3_output_from_vecs(az_vec, el_vec, gain_dB_vec, max_gain, min_gain, a, f)
+%    ns3_output_from_vecs Outputs the reference gain values
+%    as a vector of vectors.
+%    The entries of the inner vectors, representing a single test point,
+%    represent: (gain at boresight (dB), gain outside the 3GPP pattern region (dB),
+%    aperture (meters), carrier frequency (Hz), test azimuth (degrees),
+%    test elevation angle (degrees), reference antenna gain (dB))
+    out_str = '';
+    for i=1:size(el_vec, 2)
+        out_str = [out_str, '{', ...
+                            num2str(max_gain), ',', ...
+                            num2str(min_gain), ',', ...
+                            num2str(a), ',', ...
+                            num2str(f), ',', ...
+                            num2str(az_vec(i) - 180), ',', ...
+                            num2str(el_vec(i)), ',', ...
+                            num2str(gain_dB_vec(i)), '},'];
+    end
+end
